import 'dart:async';

import 'package:flutter/services.dart';

class ZolozkitForFlutter {
  static const MethodChannel _channel =
      const MethodChannel('com.zoloz.flutter.plugin/zolozkit');
  static Function _callback;

  static Future<String> get metaInfo async {
    final String metaInfo = await _channel.invokeMethod('getMetaInfo');
    return metaInfo;
  }

  static Future<String> get zolozLocale async {
    String metaInfo = await _channel.invokeMethod("getLocaleKey");
    return metaInfo;
  }

  static Future<String> get zolozChameleonConfigPath async {
    String metaInfo = await _channel.invokeMethod("getChameleonConfigPath");
    return metaInfo;
  }

  static Future<String> get zolozPublicKey async {
    String metaInfo = await _channel.invokeMethod("getPublicKey");
    return metaInfo;
  }

  static Future<void> _methodCallHandler(MethodCall call) async {
    print("dart method callhandler");
    switch (call.method) {
      case 'onResult':
        if (_callback != null) {
          _callback(call.arguments["result"]);
          _callback = null;
        }
        break;
    }
  }

  static Future start(String clientCfg, Map bizCfg, Function callback) async {
    _channel.setMethodCallHandler(_methodCallHandler);
    _callback = callback;
    await _channel.invokeMethod("start",
        {"clientCfg": clientCfg, "bizCfg": bizCfg == null ? {} : bizCfg});
  }
}
